using System;
using System.Collections.Generic;
using System.Text;
using System.Net.Sockets;
using System.IO;
using System.Net;
using System.Net.Security;
using System.Security.Cryptography.X509Certificates;
using System.Security.Authentication;

namespace LeastPrivilege
{
    class Server
    {
        static void Main(string[] args)
        {
            // server zertifikat ermitteln
            X509Certificate cert = getServerCert();

            // listener starten
            TcpListener listener = new TcpListener(IPAddress.Any, 4242);
            listener.Start();

            TcpClient client = listener.AcceptTcpClient();

            // ssl stream wrapped socket
            SslStream ssl = new SslStream(
                client.GetStream(),
                false);

            // server authentifizierungs-handshake starten
            ssl.AuthenticateAsServer(cert, false, SslProtocols.Tls, false);

            TextReader reader = new StreamReader(ssl);
            string message = reader.ReadLine();

            Console.WriteLine(message);
        }

        // server zertifikat aus dem speicher lesen - der key identifier muss hier gendert werden
        private static X509Certificate getServerCert()
        {
            X509Store store = null;

            try
            {
                store = new X509Store(StoreName.My, StoreLocation.CurrentUser);
                store.Open(OpenFlags.ReadOnly);
                X509CertificateCollection cert = store.Certificates.Find(
                    X509FindType.FindBySubjectKeyIdentifier,
                    "7bf3fe81e7185387b8ae687d36754a96ce790fe6",
                    true);

                return cert[0];
            }
            finally
            {
                store.Close();
            }
            
        }
    }
}
